/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2203 from the
 * contents of RSA.xs. Do not edit this file, edit RSA.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "RSA.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <openssl/ssl.h>
#include <openssl/bn.h>

/* Key names for the rsa hash structure */

#define KEY_KEY "_Key"
#define PADDING_KEY "_Padding"
#define HASH_KEY "_Hash_Mode"

#define PACKAGE_NAME "Crypt::OpenSSL::RSA"

#define CHECK_OPEN_SSL(p_result) if (!(p_result)) \
  croak("OpenSSL error in %s at %d: %s", \
        __FILE__, __LINE__, ERR_reason_error_string(ERR_get_error()));

/* convenience hv routines - I'm lazy */

void hvStore(HV* hv, char* key, SV* value)
{
    hv_delete(hv, key, strlen(key), G_DISCARD);

    if (hv_store(hv, key, strlen(key), value, 0) != NULL)
    {
        SvREFCNT_inc(value);
    }
}

SV** hvFetch(HV* hv, char* key)
{
    return hv_fetch(hv, key, strlen(key), 0);
}

/* Free the RSA key, if there is one */
void free_RSA_key(HV* rsa_HV)
{
    SV** rsa_ptr_SV_ptr;

    if ((rsa_ptr_SV_ptr = hvFetch(rsa_HV, KEY_KEY)) != NULL)
    {
        RSA_free((RSA*) SvIV(*rsa_ptr_SV_ptr));
        hv_delete(rsa_HV, KEY_KEY, strlen(KEY_KEY), G_DISCARD);
    }
}

RSA* get_RSA_key(HV* rsa_HV)
{
    SV** rsa_ptr_SV_ptr;

    if ((rsa_ptr_SV_ptr = hvFetch(rsa_HV, KEY_KEY)) == NULL)
    {
        croak("There is no key set");
    }
    else
    {
        return (RSA*) SvIV(*rsa_ptr_SV_ptr);
    }
}

void set_RSA_key(HV* rsa_HV, RSA* rsa)
{
    hvStore(rsa_HV, KEY_KEY, sv_2mortal(newSViv((IV)rsa)));
}

int get_padding(HV* rsa_HV)
{
    SV** padding;

    padding = hvFetch(rsa_HV, PADDING_KEY);
    return padding == NULL ? -1 : SvIV(*padding);
}

void set_padding(HV* rsa_HV, int padding)
{
    hvStore(rsa_HV, PADDING_KEY, sv_2mortal(newSViv((IV) padding)));
}

int get_hash(HV* rsa_HV)
{
    SV** hash;

    hash = hvFetch(rsa_HV, HASH_KEY);
    return hash == NULL ? -1 : SvIV(*hash);
}

void set_hash(HV* rsa_HV, int hash)
{
    hvStore(rsa_HV, HASH_KEY, sv_2mortal(newSViv((IV) hash)));
}

char is_private(HV* rsa_HV)
{
    return(get_RSA_key(rsa_HV)->d != NULL);
}

SV* make_rsa_obj(SV* p_proto, RSA* p_rsa)
{
    HV* rsa_HV;
    rsa_HV = newHV();
    hvStore(rsa_HV, KEY_KEY, sv_2mortal(newSViv((IV) p_rsa )));
    set_hash(rsa_HV, NID_sha1);
    set_padding(rsa_HV, RSA_PKCS1_OAEP_PADDING);
    return sv_bless(
        newRV_noinc((SV*) rsa_HV),
        (SvROK(p_proto) ? SvSTASH(SvRV(p_proto)) : gv_stashsv(p_proto, 1)));
}

int get_digest_length(int hash_method)
{
    switch(hash_method)
    {
        case NID_md5:
            return 16;
            break;
        case NID_sha1:
        case NID_ripemd160:
            return 20;
            break;
        default:
            croak("Unknown digest hash code");
            break;
    }
}

char* get_message_digest(SV* text_SV, int hash_method)
{
    int text_length;
    unsigned char* text;
    unsigned char* message_digest;

    text = SvPV(text_SV, text_length);

    if (New(0, message_digest, get_digest_length(hash_method), char) == NULL)
    {
        croak("unable to allocate buffer for message digest in package "
              PACKAGE_NAME);
    }

    switch(hash_method)
    {
        case NID_md5:
        {
            if (MD5(text, text_length, message_digest) == NULL)
            {
                croak("failed to compute the MD5 message digest in package "
                       PACKAGE_NAME);
            }
            break;
        }

        case NID_sha1:
        {
            if (SHA1(text, text_length, message_digest) == NULL)
            {
                croak("failed to compute the SHA1 message digest in package "
                       PACKAGE_NAME);
            }
            break;
        }
        case NID_ripemd160:
        {
            if (RIPEMD160(text, text_length, message_digest) == NULL)
            {
                croak("failed to compute the SHA1 message digest in package "
                       PACKAGE_NAME);
            }
            break;
        }
        default:
        {
            croak("Unknown digest hash code");
            break;
        }
    }
    return message_digest;
}

SV* bn2sv(BIGNUM* p_bn)
{
    return p_bn != NULL
        ? sv_2mortal(newSViv((IV) BN_dup(p_bn)))
        : &PL_sv_undef;
}

SV* extractBioString(BIO* p_stringBio)
{
    SV* sv;
    BUF_MEM* bptr;

    BIO_flush(p_stringBio);
    BIO_get_mem_ptr(p_stringBio, &bptr);
    sv = newSVpv(bptr->data, bptr->length);

    BIO_set_close(p_stringBio, BIO_CLOSE);
    BIO_free(p_stringBio);
    return sv;
}

void _load_rsa_key(HV* p_rsaHv,
                   SV* p_keyStringSv,
                   RSA*(*p_loader)(BIO*, RSA**, pem_password_cb*, void*))
{
    int keyStringLength;  /* Needed to pass to SvPV */
    char* keyString;

    RSA* rsa;
    BIO* stringBIO;

    /* First; remove any old rsa structures, to avoid leakage */
    free_RSA_key(p_rsaHv);

    keyString = SvPV(p_keyStringSv, keyStringLength);

    CHECK_OPEN_SSL(stringBIO = BIO_new_mem_buf(keyString, keyStringLength))

    rsa = p_loader(stringBIO, NULL, NULL, NULL);

    BIO_set_close(stringBIO, BIO_CLOSE);
    BIO_free(stringBIO);

    CHECK_OPEN_SSL(rsa)
    set_RSA_key(p_rsaHv, rsa);
}

#line 238 "RSA.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 290 "RSA.c"

XS(XS_Crypt__OpenSSL__RSA_load_private_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_load_private_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "rsa_HV, key_string_SV");
    {
	HV*	rsa_HV;
	SV*	key_string_SV = ST(1);

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 239 "RSA.xs"
    _load_rsa_key(rsa_HV, key_string_SV, PEM_read_bio_RSAPrivateKey);
#line 316 "RSA.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__RSA__load_public_pkcs1_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA__load_public_pkcs1_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "rsa_HV, key_string_SV");
    {
	HV*	rsa_HV;
	SV*	key_string_SV = ST(1);

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 246 "RSA.xs"
    _load_rsa_key(rsa_HV, key_string_SV, PEM_read_bio_RSAPublicKey);
#line 346 "RSA.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__RSA__load_public_x509_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA__load_public_x509_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "rsa_HV, key_string_SV");
    {
	HV*	rsa_HV;
	SV*	key_string_SV = ST(1);

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 253 "RSA.xs"
    _load_rsa_key(rsa_HV, key_string_SV, PEM_read_bio_RSA_PUBKEY);
#line 376 "RSA.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__RSA__free_RSA_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA__free_RSA_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    {
	HV*	rsa_HV;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 259 "RSA.xs"
    free_RSA_key(rsa_HV);
#line 405 "RSA.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__RSA_get_private_key_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_get_private_key_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    {
	HV*	rsa_HV;
#line 265 "RSA.xs"
    BIO* stringBIO;
#line 425 "RSA.c"
	SV *	RETVAL;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 267 "RSA.xs"
    CHECK_OPEN_SSL(stringBIO = BIO_new(BIO_s_mem()))
    PEM_write_bio_RSAPrivateKey(
        stringBIO, get_RSA_key(rsa_HV), NULL, NULL, 0, NULL, NULL);
    RETVAL = extractBioString(stringBIO);

#line 442 "RSA.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__RSA_get_public_key_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_get_public_key_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    {
	HV*	rsa_HV;
#line 279 "RSA.xs"
    BIO* stringBIO;
#line 464 "RSA.c"
	SV *	RETVAL;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 281 "RSA.xs"
    CHECK_OPEN_SSL(stringBIO = BIO_new(BIO_s_mem()))
    PEM_write_bio_RSAPublicKey(stringBIO, get_RSA_key(rsa_HV));
    RETVAL = extractBioString(stringBIO);

#line 480 "RSA.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__RSA_get_public_key_x509_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_get_public_key_x509_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    {
	HV*	rsa_HV;
#line 292 "RSA.xs"
    BIO* stringBIO;
#line 502 "RSA.c"
	SV *	RETVAL;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 294 "RSA.xs"
    CHECK_OPEN_SSL(stringBIO = BIO_new(BIO_s_mem()))
    PEM_write_bio_RSA_PUBKEY(stringBIO, get_RSA_key(rsa_HV));
    RETVAL = extractBioString(stringBIO);

#line 518 "RSA.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__RSA__generate_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA__generate_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "rsa_HV, bitsSV, ...");
    {
	HV*	rsa_HV;
	SV*	bitsSV = ST(1);
#line 311 "RSA.xs"
    RSA* rsa;
    unsigned long exponent;
#line 542 "RSA.c"

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 314 "RSA.xs"
{
    if (items > 3)
    {
        croak("Usage: rsa->generate_key($bits [, $exponent])");
    }

    exponent = (items == 3) ? SvIV(ST(2)) : 65535;
    CHECK_OPEN_SSL(rsa = RSA_generate_key(SvIV(bitsSV), exponent, NULL, NULL))
    set_RSA_key(rsa_HV, rsa);
}
#line 563 "RSA.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__RSA__new_key_from_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA__new_key_from_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 6)
       croak_xs_usage(cv,  "proto, n, e, d, p, q");
    {
	SV*	proto = ST(0);
	BIGNUM*	n = INT2PTR(BIGNUM *,SvIV(ST(1)));
	BIGNUM*	e = INT2PTR(BIGNUM *,SvIV(ST(2)));
	BIGNUM*	d = INT2PTR(BIGNUM *,SvIV(ST(3)));
	BIGNUM*	p = INT2PTR(BIGNUM *,SvIV(ST(4)));
	BIGNUM*	q = INT2PTR(BIGNUM *,SvIV(ST(5)));
#line 334 "RSA.xs"
    RSA* rsa;
    BN_CTX* ctx;
    BIGNUM* bn;
    BIGNUM* p_minus_1;
    BIGNUM* q_minus_1;
#line 592 "RSA.c"
	SV *	RETVAL;
#line 340 "RSA.xs"
{
    if (!(n && e))
    {
        croak("At least a modulous and public key must be provided");
    }
    rsa = RSA_new();
    rsa->n = n;
    rsa->e = e;
    if (p || q)
    {
        bn = BN_new();
        ctx = BN_CTX_new();
        if (!p)
        {
            p = BN_new();
            CHECK_OPEN_SSL(BN_div(p, bn, n, q, ctx))
            if (! BN_is_zero(bn))
            {
                croak("q does not divide n");
            }
        }
        else if (! q)
        {
            q = BN_new();
            CHECK_OPEN_SSL(BN_div(q, bn, n, p, ctx))
            if (! BN_is_zero(bn))
            {
                croak("p does not divide n");
            }
        }
        rsa->p = p;
        rsa->q = q;
        p_minus_1 = BN_new();
        CHECK_OPEN_SSL(BN_sub(p_minus_1, p, BN_value_one()))
        q_minus_1 = BN_new();
        CHECK_OPEN_SSL(BN_sub(q_minus_1, q, BN_value_one()))
        if (!d)
        {
            d = BN_new();
            CHECK_OPEN_SSL(BN_mul(bn, p_minus_1, q_minus_1, ctx))
            CHECK_OPEN_SSL(BN_mod_inverse(d, e, bn, ctx))
        }
        rsa->d = d;
        rsa->dmp1 = BN_new();
        CHECK_OPEN_SSL(BN_mod(rsa->dmp1, d, p_minus_1, ctx))
        rsa->dmq1 = BN_new();
        CHECK_OPEN_SSL(BN_mod(rsa->dmq1, d, q_minus_1, ctx))
        rsa->iqmp = BN_new();
        CHECK_OPEN_SSL(BN_mod_inverse(rsa->iqmp, q, p, ctx))
        BN_clear_free(bn);
        BN_clear_free(p_minus_1);
        BN_clear_free(q_minus_1);
    }
    else
    {
        rsa->d = d;
    }
    RETVAL = make_rsa_obj(proto, rsa);
}
#line 654 "RSA.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__RSA__get_key_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA__get_key_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	HV*	rsa_HV;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 406 "RSA.xs"
{
    RSA* rsa;
    rsa = get_RSA_key(rsa_HV);
    XPUSHs(bn2sv(rsa->n));
    XPUSHs(bn2sv(rsa->e));
    XPUSHs(bn2sv(rsa->d));
    XPUSHs(bn2sv(rsa->p));
    XPUSHs(bn2sv(rsa->q));
    XPUSHs(bn2sv(rsa->dmp1));
    XPUSHs(bn2sv(rsa->dmq1));
    XPUSHs(bn2sv(rsa->iqmp));
}
#line 698 "RSA.c"
	PUTBACK;
	return;
    }
}


XS(XS_Crypt__OpenSSL__RSA_encrypt); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_encrypt)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "rsa_HV, plaintext_SV, ...");
    {
	HV*	rsa_HV;
	SV*	plaintext_SV = ST(1);
#line 426 "RSA.xs"
    int plaintext_length;
    unsigned char* plaintext;
    unsigned char* ciphertext;
    size_t size;
    int ciphertext_length;
    RSA* rsa;
#line 725 "RSA.c"
	SV *	RETVAL;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 433 "RSA.xs"
    plaintext = SvPV(plaintext_SV, plaintext_length);

    rsa = get_RSA_key(rsa_HV);

    size = RSA_size(rsa);
    if (New(0,ciphertext, size, char) == NULL)
    {
        croak("unable to allocate buffer for ciphertext in package "
              PACKAGE_NAME);
    }

    ciphertext_length = RSA_public_encrypt(
        plaintext_length, plaintext, ciphertext, rsa, get_padding(rsa_HV));

    if (ciphertext_length < 0)
    {
        Safefree(ciphertext);
        CHECK_OPEN_SSL(0)
    }

    RETVAL = newSVpv(ciphertext, size);
#line 758 "RSA.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__RSA_decrypt); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_decrypt)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "rsa_HV, ciphertext_SV");
    {
	HV*	rsa_HV;
	SV*	ciphertext_SV = ST(1);
#line 464 "RSA.xs"
    int ciphertext_length;  /* Needed to pass to SvPV */
    int plaintext_length;
    char* plaintext;
    char* ciphertext;
    unsigned long size;
    RSA* rsa;
#line 786 "RSA.c"
	SV *	RETVAL;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 471 "RSA.xs"
{
    if (! is_private(rsa_HV))
    {
        croak("Public keys cannot decrypt messages.");
    }

    ciphertext = SvPV(ciphertext_SV, ciphertext_length);

    rsa = get_RSA_key(rsa_HV);
    size = RSA_size(rsa);
    if (New(0, plaintext, size, char) == NULL)
    {
        croak("unable to allocate buffer for plaintext in package "
               PACKAGE_NAME);
    }

    plaintext_length = RSA_private_decrypt(
        size, ciphertext, plaintext, rsa, get_padding(rsa_HV));

    if (plaintext_length < 0)
    {
        Safefree(plaintext);
        CHECK_OPEN_SSL(0)
    }

    RETVAL = newSVpv(plaintext, plaintext_length);
    Safefree(plaintext);
}
#line 826 "RSA.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__RSA_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    {
	HV*	rsa_HV;
	int	RETVAL;
	dXSTARG;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 506 "RSA.xs"
    RETVAL = RSA_size(get_RSA_key(rsa_HV));
#line 859 "RSA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__RSA_check_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_check_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    {
	HV*	rsa_HV;
	int	RETVAL;
	dXSTARG;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 514 "RSA.xs"
    RETVAL = RSA_check_key(get_RSA_key(rsa_HV));
#line 891 "RSA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__RSA__random_seed); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA__random_seed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "random_bytes_SV");
    {
	SV*	random_bytes_SV = ST(0);
#line 525 "RSA.xs"
    int random_bytes_length;
    char* random_bytes;
#line 913 "RSA.c"
	int	RETVAL;
	dXSTARG;
#line 528 "RSA.xs"
    random_bytes = SvPV(random_bytes_SV, random_bytes_length);
    RAND_seed(random_bytes, random_bytes_length);
    RETVAL = RAND_status();
#line 920 "RSA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__RSA__random_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA__random_status)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 539 "RSA.xs"
    RETVAL = RAND_status();
#line 942 "RSA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__RSA_use_md5_hash); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_use_md5_hash)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    {
	HV*	rsa_HV;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 549 "RSA.xs"
    set_hash(rsa_HV, NID_md5);
#line 972 "RSA.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__RSA_use_sha1_hash); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_use_sha1_hash)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    {
	HV*	rsa_HV;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 555 "RSA.xs"
    set_hash(rsa_HV, NID_sha1);
#line 1001 "RSA.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__RSA_use_ripemd160_hash); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_use_ripemd160_hash)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    {
	HV*	rsa_HV;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 561 "RSA.xs"
    set_hash(rsa_HV, NID_ripemd160);
#line 1030 "RSA.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__RSA_use_no_padding); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_use_no_padding)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    {
	HV*	rsa_HV;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 567 "RSA.xs"
    set_padding(rsa_HV, RSA_NO_PADDING);
#line 1059 "RSA.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__RSA_use_pkcs1_padding); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_use_pkcs1_padding)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    {
	HV*	rsa_HV;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 573 "RSA.xs"
    set_padding(rsa_HV, RSA_PKCS1_PADDING);
#line 1088 "RSA.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__RSA_use_pkcs1_oaep_padding); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_use_pkcs1_oaep_padding)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    {
	HV*	rsa_HV;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 579 "RSA.xs"
    set_padding(rsa_HV, RSA_PKCS1_OAEP_PADDING);
#line 1117 "RSA.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__RSA_use_sslv23_padding); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_use_sslv23_padding)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "rsa_HV");
    {
	HV*	rsa_HV;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 585 "RSA.xs"
    set_padding(rsa_HV, RSA_SSLV23_PADDING);
#line 1146 "RSA.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__RSA_sign); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_sign)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2)
       croak_xs_usage(cv,  "rsa_HV, text_SV, ...");
    {
	HV*	rsa_HV;
	SV*	text_SV = ST(1);
#line 592 "RSA.xs"
    unsigned char* signature;
    char* digest;
    int signature_length;
    int hash;
    RSA* rsa;
#line 1171 "RSA.c"
	SV *	RETVAL;

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 598 "RSA.xs"
    if (! is_private(rsa_HV))
    {
        croak("Public keys cannot sign messages.");
    }

    rsa = get_RSA_key(rsa_HV);

    if (New(0, signature, RSA_size(rsa), char) == NULL)
    {
        croak("unable to allocate buffer for ciphertext in package "
               PACKAGE_NAME);
    }

    hash = get_hash(rsa_HV);
    digest = get_message_digest(text_SV, hash);
    if (! RSA_sign(hash,
                   digest,
                   get_digest_length(hash),
                   signature,
                   &signature_length,
                   rsa))
    {
        CHECK_OPEN_SSL(0)
    }
    Safefree(digest);
    RETVAL = newSVpvn(signature, signature_length);
    Safefree(signature);
#line 1210 "RSA.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__RSA_verify); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__RSA_verify)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3)
       croak_xs_usage(cv,  "rsa_HV, text_SV, sig_SV, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	HV*	rsa_HV;
	SV*	text_SV = ST(1);
	SV*	sig_SV = ST(2);

    if (! ( SvROK( ST(0) ) && sv_derived_from( ST(0), PACKAGE_NAME ) ) )
    {
        croak( "scalar is not a " PACKAGE_NAME " object" );
    }
    if ( SvTYPE( rsa_HV = (HV *) SvRV(ST(0)) ) != SVt_PVHV )
    {
        croak( "Passed scalar is not a hash reference" );
    };
#line 636 "RSA.xs"
{
    unsigned char* sig;
    char* digest;
    RSA* rsa;
    int sig_length;
    int hash;
    int result;

    if (is_private(rsa_HV))
    {
        croak("Secret keys should not check signatures.");
    }

    sig = SvPV(sig_SV, sig_length);
    rsa = get_RSA_key(rsa_HV);
    if (RSA_size(rsa) < sig_length)
    {
        croak("Signature longer than key");
    }

    hash = get_hash(rsa_HV);
    digest = get_message_digest(text_SV, hash);
    result = RSA_verify(
        hash, digest, get_digest_length(hash), sig, sig_length, rsa);
    Safefree(digest);
    switch(result)
    {
        case 0: /* FIXME - could there be an error in this case? */
            XSRETURN_NO;
            break;
        case 1:
            XSRETURN_YES;
            break;
        default:
            CHECK_OPEN_SSL(0)
            break;
    }
}
#line 1282 "RSA.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Crypt__OpenSSL__RSA); /* prototype to pass -Wmissing-prototypes */
XS(boot_Crypt__OpenSSL__RSA)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("Crypt::OpenSSL::RSA::load_private_key", XS_Crypt__OpenSSL__RSA_load_private_key, file);
        newXS("Crypt::OpenSSL::RSA::_load_public_pkcs1_key", XS_Crypt__OpenSSL__RSA__load_public_pkcs1_key, file);
        newXS("Crypt::OpenSSL::RSA::_load_public_x509_key", XS_Crypt__OpenSSL__RSA__load_public_x509_key, file);
        newXS("Crypt::OpenSSL::RSA::_free_RSA_key", XS_Crypt__OpenSSL__RSA__free_RSA_key, file);
        newXS("Crypt::OpenSSL::RSA::get_private_key_string", XS_Crypt__OpenSSL__RSA_get_private_key_string, file);
        newXS("Crypt::OpenSSL::RSA::get_public_key_string", XS_Crypt__OpenSSL__RSA_get_public_key_string, file);
        newXS("Crypt::OpenSSL::RSA::get_public_key_x509_string", XS_Crypt__OpenSSL__RSA_get_public_key_x509_string, file);
        newXS("Crypt::OpenSSL::RSA::_generate_key", XS_Crypt__OpenSSL__RSA__generate_key, file);
        newXS("Crypt::OpenSSL::RSA::_new_key_from_parameters", XS_Crypt__OpenSSL__RSA__new_key_from_parameters, file);
        newXS("Crypt::OpenSSL::RSA::_get_key_parameters", XS_Crypt__OpenSSL__RSA__get_key_parameters, file);
        newXS("Crypt::OpenSSL::RSA::encrypt", XS_Crypt__OpenSSL__RSA_encrypt, file);
        newXS("Crypt::OpenSSL::RSA::decrypt", XS_Crypt__OpenSSL__RSA_decrypt, file);
        newXS("Crypt::OpenSSL::RSA::size", XS_Crypt__OpenSSL__RSA_size, file);
        newXS("Crypt::OpenSSL::RSA::check_key", XS_Crypt__OpenSSL__RSA_check_key, file);
        newXS("Crypt::OpenSSL::RSA::_random_seed", XS_Crypt__OpenSSL__RSA__random_seed, file);
        newXS("Crypt::OpenSSL::RSA::_random_status", XS_Crypt__OpenSSL__RSA__random_status, file);
        newXS("Crypt::OpenSSL::RSA::use_md5_hash", XS_Crypt__OpenSSL__RSA_use_md5_hash, file);
        newXS("Crypt::OpenSSL::RSA::use_sha1_hash", XS_Crypt__OpenSSL__RSA_use_sha1_hash, file);
        newXS("Crypt::OpenSSL::RSA::use_ripemd160_hash", XS_Crypt__OpenSSL__RSA_use_ripemd160_hash, file);
        newXS("Crypt::OpenSSL::RSA::use_no_padding", XS_Crypt__OpenSSL__RSA_use_no_padding, file);
        newXS("Crypt::OpenSSL::RSA::use_pkcs1_padding", XS_Crypt__OpenSSL__RSA_use_pkcs1_padding, file);
        newXS("Crypt::OpenSSL::RSA::use_pkcs1_oaep_padding", XS_Crypt__OpenSSL__RSA_use_pkcs1_oaep_padding, file);
        newXS("Crypt::OpenSSL::RSA::use_sslv23_padding", XS_Crypt__OpenSSL__RSA_use_sslv23_padding, file);
        newXS("Crypt::OpenSSL::RSA::sign", XS_Crypt__OpenSSL__RSA_sign, file);
        newXS("Crypt::OpenSSL::RSA::verify", XS_Crypt__OpenSSL__RSA_verify, file);

    /* Initialisation Section */

#line 232 "RSA.xs"
    ERR_load_crypto_strings();

#line 1340 "RSA.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

